=== modified file 'bzrlib/tests/test_transport.py'
--- bzrlib/tests/test_transport.py	2010-09-01 18:43:32 +0000
+++ bzrlib/tests/test_transport.py	2010-10-08 07:17:16 +0000
@@ -31,6 +31,7 @@
 from bzrlib.transport import (
     chroot,
     fakenfs,
+    http,
     local,
     memory,
     pathfilter,
@@ -993,3 +994,14 @@
         # And the rest are threads
         for t in started[1:]:
             t.join()
+
+
+class TestUnhtml(tests.TestCase):
+
+    """Tests for unhtml_roughly"""
+
+    def test_truncation(self):
+        fake_html = "<p>something!\n" * 1000
+        result = http.unhtml_roughly(fake_html)
+        self.assertEquals(len(result), 1000)
+        self.assertStartsWith(result, " something!")

=== modified file 'bzrlib/transport/http/__init__.py'
--- bzrlib/transport/http/__init__.py	2010-10-08 04:38:25 +0000
+++ bzrlib/transport/http/__init__.py	2010-10-08 07:17:16 +0000
@@ -668,10 +668,12 @@
         pass
 
 
-def unhtml_roughly(maybe_html):
+def unhtml_roughly(maybe_html, length_limit=1000):
     """Very approximate html->text translation, for presenting error bodies.
 
+    :param length_limit: Truncate the result to this many characters.
+
     >>> unhtml_roughly("<b>bad</b> things happened\\n")
     ' bad  things happened '
     """
-    return re.subn(r"(<[^>]*>|\n|&nbsp;)", " ", maybe_html)[0]
+    return re.subn(r"(<[^>]*>|\n|&nbsp;)", " ", maybe_html)[0][:length_limit]

